//+---------------------------------------------------------------------+
//| Modified to use NonLagMA_v7;    RK 3-19-2010 RK-NonLagMA_EAw3MAs.mq4                   
//| "Mr Kims" critereia, MACD & MA H&L Channels to Trade                         
//| Using NLMA instead of Ma Applied Price.  3-16-10                                                               
//| Tried Macd w/out "above 0" option its not as good as "above 0" 3-19-10 
//+---------------------------------------------------------------------+
#property copyright "RH & RK"
#property link      "None"
#include <stdlib.mqh>
#include <stderror.mqh> 
extern string Expert_Name       = "RKNonLag_EAw4MA-Nims";
extern string Indicator_Used    = "NonLagMA-MACD-MA";

extern bool    Debug          = false;
//|Account functions                                  |
extern bool    AccountIsMini  = true;     // Change to true if trading mini account
//|Money Management                                   |
extern bool   MoneyManagement = false;    // Change to false to shutdown money management controls.
                                    // Lots = 1 will be in effect and only 1 lot will be open regardless of equity.
extern double TradeSizePercent= 10;       // Change to whatever percent of equity you wish to risk.
extern double Lots            = 1;      // standard lot size. 
double        MaxLots         = 1;
//|Profit controls                                    |
extern double  StopLoss       = 0;        // Maximum pips willing to lose per position.
extern int     TakeProfit     = 0;        // 0= Off, Maximum profit level achieved.
extern bool   UseTrailingStop = false;
extern int   TrailingStopType = 0;        //Type 1 moves stop immediately, Type 2 waits til value of TS is reached
extern double  TrailingStop   = 0;        // Change to whatever number of pips you wish to trail your position with.
extern int     Slippage       = 5;        // Possible fix for not getting filled or closed    

extern string ____ExitMode___ = "Use MMs: 0=off/Signal exits, 1= MM ONLY: SL-TP Exits ONLY" ;
extern int        ExitMode    = 0;    // 0-off/Signal exits, 1= MM: SL-TP Exits" ;

extern string  Time_Inputs    = " Timing parameters ";
extern int     StartHour      = 0;        // Start Hour of Trade Session 
extern int     StartMinute    = 0;        // Start Minute of Trade Session 
extern int     EndHour        = 23;        // End Hour of Trade Session
extern int     EndMinute      = 0;        // End Hour of Trade Session

extern string  Indicator_Inputs = " - indicator parameters--";
extern int     Price          = 0;   //Apply to Price(0-C;1-O;2-H;3-L;4-Md Pr;5-Typ'l Pr;6-Wghtd Close) 
extern int     Length         = 5;  //Period of NonLagMA
extern double  PctFilter      = 1.5;  //Dynamic filter in decimal

extern int     KCperiod       = 7; //Keltner Channel Length

extern int     MAPeriod       = 15;
extern int     MAType         = 1; //0-sma,1-ema,2-smma,3-lwma,4-lsma,
extern int     FastEMA        = 5;
extern int     SlowEMA        = 10;
extern int     SignalSMA      = 5;

extern bool    ecnBroker      = true;

datetime       timeprev       = 0;
double   myStopLoss;   
double   lotMM;
int      MagicNumber;
string   setup = "";
int      totalTries = 5; 
int      retryDelay = 1000;
double pointvalue;

int init() 
{
	MagicNumber = 5000 + func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(Period()); 
   setup="NonLagMA_EAw4MA-Nims " + Symbol() + "_" + func_TimeFrame_Val2String(func_TimeFrame_Const2Val(Period()));

    //Convert to 3 & 5 diget broker
    if (Digits == 4 || Digits == 2) pointvalue = Point;
      else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
}

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;
   else
   if (StartHour > EndHour)
   result = (TimeCurrent() > SessionStart && TimeHour(TimeCurrent()) < 24)||
                              (TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   return(result);
}   

bool BuySignal() 
{
   double MACDC=iCustom(NULL, 0,"MACD",FastEMA,SlowEMA,SignalSMA,0,0);
   double MACDP=iCustom(NULL, 0,"MACD",FastEMA,SlowEMA,SignalSMA,0,1);
   double MAH=iCustom(NULL, 0,"RK-MA-H",5,0,2,2,0,0);
   double NLMAC = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,0);   
   double NLMAP1 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,1);
   double NLMAP2 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,2);
   double NLMAP3 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,3);
   double upper=iCustom(NULL, 0,"KeltnerChannel",KCperiod,0,0);
   double MA = iCustom(NULL, 0,"MA in Color",MAPeriod,MAType,0,0);
  
  if (
     NLMAC > NLMAP1 //&& NLMAP1 < NLMAP2 
     && NLMAP1 > NLMAP2
     && MACDC > 0
     //&& MACDC > MACDP
     && Close[1] > MAH
     && Close[1] > MA
     && TimeCondition()) return(true); return(false);
}
bool SellSignal()
{
   double MACDC=iCustom(NULL, 0,"MACD",FastEMA,SlowEMA,SignalSMA,0,0);
   double MACDP=iCustom(NULL, 0,"MACD",FastEMA,SlowEMA,SignalSMA,0,1);
   double MAL=iCustom(NULL, 0,"RK-MA-L",5,0,2,3,0,0);
   double NLMAC = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,0);   
   double NLMAP1 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,1);
   double NLMAP2 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,2);
   double NLMAP3 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,3);
   double lower=iCustom(NULL, 0,"KeltnerChannel",KCperiod,2,0);
   double MA = iCustom(NULL, 0,"MA in Color",MAPeriod,MAType,0,0);
  if (
     NLMAC < NLMAP1  //&& NLMAP1 > NLMAP2       //enter on reversal only
     && NLMAP1 < NLMAP2                      
     && MACDC < 0
     //&& MACDC < MACDP
     && Close[1] < MAL
     && Close[1] < MA
     && TimeCondition()) return(true); return (false);
}
bool BuyExitSignal()
{
   double MACDC=iCustom(NULL, 0,"MACD",FastEMA,SlowEMA,SignalSMA,0,0);
   double MACDP=iCustom(NULL, 0,"MACD",FastEMA,SlowEMA,SignalSMA,0,1);
   double NLMAC = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,0);   
   double NLMAP1 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,1);
   double NLMAP2 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,2);
   double NLMAP3 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,3);
   double upper=iCustom(NULL, 0,"KeltnerChannel",KCperiod,0,0);
  if (ExitMode ==0
     && NLMAC < NLMAP1
     && NLMAP1 < NLMAP2
     //&& MACDC < MACDP
     //&& Close[0] < upper  // && MACDC < MACDP   //&& Close[1] < MAH //&& Open [1] < MAH 
     || !TimeCondition()) return(true); return(false); 
}
bool SellExitSignal()
{
   double MACDC=iCustom(NULL, 0,"MACD",FastEMA,SlowEMA,SignalSMA,0,0);
   double MACDP=iCustom(NULL, 0,"MACD",FastEMA,SlowEMA,SignalSMA,0,1);
   double NLMAC = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,0);   
   double NLMAP1 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,1);
   double NLMAP2 = iCustom(Symbol(),0,"NonLagMA_v7",Price,Length,0,PctFilter,1,1,0,0,0,2);
   double lower=iCustom(NULL, 0,"KeltnerChannel",KCperiod,2,0); 
    if (ExitMode ==0
    && NLMAC > NLMAP1
    && NLMAP1 > NLMAP2
    //&& MACDC > MACDP
    //&& Close[0] > lower     //&& MACDC > MACDP   //&& Close[1] > MAL
     || !TimeCondition()) return(true); return(false); 
}

int start()
{
  
    // Only run once per completed bar L-118
     if(timeprev==Time[0]) return(0);
     timeprev = Time[0];
   
//+------------------------------------------------------------------+
//| Check for Open Position                                          |
//+------------------------------------------------------------------+
   
  HandleOpenPositions();
  
//+------------------------------------------------------------------+
//| Check if OK to make new trades                                   |
//+------------------------------------------------------------------+
    
if (TimeCondition())
   { 

// Only allow 1 trade per Symbol
     
  if (CheckOpenPositions() > 0) return(0);
   
   lotMM = GetLots();
  
   if( BuySignal()) //&& Close[1] > upper)  
      {
	     OpenBuyOrder();
         return(0);
      }
     
      if(SellSignal()) //&& Close[1] < lower) 
      {
      OpenSellOrder();
      }
      return(0);
  }
}
//+------------------------------------------------------------------+187
//| OpenBuyOrder                                                     |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+ 
void OpenBuyOrder()
{
   int ticket;
   int cnt, err, digits;
   double myStopLoss = 0, myTakeProfit = 0, myPrice = 0 ;
   double modifyDone;
   
   myPrice = MarketInfo(Symbol(), MODE_ASK);
   myStopLoss = 0;
   if ( StopLoss > 0 ) myStopLoss = myPrice - StopLoss * pointvalue ;
	if (myStopLoss != 0) ValidStopLoss(OP_BUY, myStopLoss); 
   //Print ("-myStoploss--",myStopLoss);
   
   myTakeProfit = 0;
   if (TakeProfit>0) myTakeProfit = myPrice + TakeProfit * pointvalue;
    //Print ("-myTakeProfit--",myTakeProfit);
	// Normalize all price / stoploss / takeprofit to the proper # of digits.
   digits = MarketInfo(Symbol(), MODE_DIGITS);
	if (digits > 0) 
	{
		myPrice = NormalizeDouble(myPrice, digits);
	   myStopLoss = NormalizeDouble(myStopLoss, digits);
	   myTakeProfit = NormalizeDouble(myTakeProfit, digits); 
	}
   
  //New ECN Option
   if (ecnBroker)
   {
     ticket = OrderSend(Symbol(), OP_BUY, lotMM, myPrice, Slippage, 0, 0, setup, MagicNumber, 0, DodgerBlue);
     Print("BUY order opened : ------------------------------------ticket #  " , ticket ,"   ", OrderOpenPrice());
     
     if(ticket > 0)
     {
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
          {
                  OrderModify(ticket,OrderOpenPrice(),myStopLoss, myTakeProfit,0,DarkRed);
                     Print("BUY order opened : ------------------------------------ticket #  " , ticket ,"   ", OrderOpenPrice());
          }                     
     }
     else Print("Error opening BUY order : ", GetLastError());
   } 
  else         
   {
     ticket = OrderSend(Symbol(), OP_BUY, lotMM, myPrice, Slippage, myStopLoss, myTakeProfit, setup,
                                                                                  MagicNumber, 0, DodgerBlue);
     if(ticket > 0)
            {
               if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                   Print("BUY order opened : ---------------------------------- ticket #  " , ticket ,"   " , OrderOpenPrice());
            }
            else Print("Error opening BUY order : ", GetLastError());
    }                 
 }

//+------------------------------------------------------------------+
//| OpenSellOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+ 220
void OpenSellOrder()
{
   int ticket;
   int cnt, err, digits;
   double myStopLoss = 0, myTakeProfit = 0, myPrice = 0;
   double modifyDone;
   
   myPrice = MarketInfo(Symbol(), MODE_BID);
   myStopLoss = 0;
   if ( StopLoss > 0 ) myStopLoss = myPrice + StopLoss * pointvalue ;
	if (myStopLoss != 0) ValidStopLoss(OP_SELL, myStopLoss); 

   myTakeProfit = 0;
   if (TakeProfit > 0) myTakeProfit = myPrice - TakeProfit * pointvalue;
       
	// Normalize all price / stoploss / takeprofit to the proper # of digits.
	digits = MarketInfo(Symbol(), MODE_DIGITS);
	if (digits > 0) 
	{
	   myPrice = NormalizeDouble(myPrice, digits);
	   myStopLoss = NormalizeDouble(myStopLoss, digits);
	   myTakeProfit = NormalizeDouble(myTakeProfit, digits); 
	}
	
	 //New ECN Option
   if (ecnBroker)
   {
     ticket = OrderSend(Symbol(), OP_SELL, lotMM, myPrice, Slippage, 0, 0, setup,
                                           MagicNumber, 0, Red);
     if(ticket > 0)
     {
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
          {
                  OrderModify(ticket,OrderOpenPrice(),myStopLoss, myTakeProfit,0,DarkRed);
                     Print("Sell order opened : ---------------------------------ticket #  " , ticket,"   ", OrderOpenPrice());
          }                     
     }
     else Print("Error opening Sell order : ", GetLastError());
   } 
  else         
   {
     ticket = OrderSend(Symbol(), OP_SELL, lotMM, myPrice, Slippage, myStopLoss, 
                                    myTakeProfit, setup, MagicNumber, 0, Red);
     if(ticket > 0)
            {
               if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                   Print("Sell order opened :----------------------------------------- ticket #  " , ticket    ,"   ", OrderOpenPrice());
            }
            else Print("Error opening Sell order : ", GetLastError());
    }                 
 
	return(0);
}
//+------------------------------------------------------------------+
//| Check Open Position Controls                                     |
//+------------------------------------------------------------------+276 
int CheckOpenPositions()
{
   int cnt, total, NumPositions;
   int NumBuyTrades, NumSellTrades;   // Number of buy and sell trades in this symbol
   
   NumBuyTrades = 0;
   NumSellTrades = 0;
   total=OrdersTotal();
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
     {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      
      if(OrderType() == OP_BUY )  NumBuyTrades++;
      if(OrderType() == OP_SELL ) NumSellTrades++;
             
     }
     NumPositions = NumBuyTrades + NumSellTrades;
     return (NumPositions);
}
//+------------------------------------------------------------------+
//| Modify Open Position Controls                                    |
//|  Try to modify position 3 times                                  |
//+------------------------------------------------------------------+ 
bool ModifyOrder(int nOrderType, int ord_ticket,double op, double price,double tp , color mColor = CLR_NONE)
{
    int cnt, err;
    double myStop;
    
    myStop = ValidStopLoss (nOrderType, price);
    cnt=0;
    while (cnt < totalTries)
    {
       if (OrderModify(ord_ticket,op,myStop,tp,0,mColor))
       {
         return(true);
       }
       else
       {
          err=GetLastError();
          if (err > 1) Print(cnt," Error modifying order : (", ord_ticket , ") " 
                                   + ErrorDescription(err), " err ",err);
          
          if (err>0) cnt++;
          Sleep(retryDelay);
       }
    }
    return(false);
}

// 	Adjust stop loss so that it is legal.
double ValidStopLoss(int cmd, double sl)
{
   
   if (sl == 0) return(0.0);
   
   double mySL, myPrice;
   double dblMinStopDistance = MarketInfo(Symbol(),MODE_STOPLEVEL)*MarketInfo(Symbol(), MODE_POINT);
   
   mySL = sl;
   
// Check if SlopLoss needs to be modified

   switch(cmd)
   {
   case OP_BUY:
      myPrice = MarketInfo(Symbol(), MODE_BID);
	   if (myPrice - sl < dblMinStopDistance) 
		mySL = myPrice - dblMinStopDistance;	// we are long
		break;
      
   case OP_SELL:
      myPrice = MarketInfo(Symbol(), MODE_ASK);
	   if (sl - myPrice < dblMinStopDistance) 
		mySL = myPrice + dblMinStopDistance;	// we are long

   }
   return(NormalizeDouble(mySL,MarketInfo(Symbol(), MODE_DIGITS)));
}


//+------------------------------------------------------------------+
//| HandleTrailingStop                                               |
//| Type 1 moves the stoploss without delay.                         |
//| Type 2 waits for price to move the amount of the trailStop       |
//| before moving stop loss then moves like type 1                   |
//| 3- 5 NOT USDE-Type 3 uses up to 3 levels for trailing stop       |
//|      Level 1 Move stop to 1st level                              |
//|      Level 2 Move stop to 2nd level                              |
//|      Level 3 Trail like type 1 by fixed amount other than 1      |
//| Possible future types                                            |
//| Type 4 uses 2 for 1, every 2 pip move moves stop 1 pip           |
//| Type 5 uses 3 for 1, every 3 pip move moves stop 1 pip           |
//+------------------------------------------------------------------+ 371
int HandleTrailingStop(int type, int ticket, double op, double os, double tp)
{
    double pt, myAsk, myBid;// TS=0;
    //double bos,bop,opa,osa; items not used
    
    switch(type)
    {
       case OP_BUY:
       {
		 myBid = MarketInfo(Symbol(),MODE_BID);
       switch(TrailingStopType)
       {
        case 1: pt = pointvalue*StopLoss;
                if(myBid-os > pt)
                 ModifyOrder(type, ticket,op,myBid-pt,tp, Aqua);
                break;
        case 2: pt = pointvalue*TrailingStop;
                if(myBid-op > pt && os < myBid - pt)
                 ModifyOrder(type, ticket,op,myBid-pt,tp, Aqua);
                break;
       }
       return(0);
       break;
       }
    case  OP_SELL:
    {
		myAsk = MarketInfo(Symbol(),MODE_ASK);
       switch(TrailingStopType)
       {
        case 1: pt = pointvalue*StopLoss;
                if(os - myAsk > pt)
                 ModifyOrder(type, ticket,op,myAsk+pt,tp, Aqua);
                 break;
        case 2: pt = pointvalue*TrailingStop;
                if(op - myAsk > pt && os < myAsk+pt)//ok
                 ModifyOrder(type, ticket,op,myAsk+pt,tp, Aqua);
                 break;
       }
    }
    return(0);
    }
}

//+------------------------------------------------------------------+
//| Handle Open Positions                                            |
//| Check if any open positions need to be closed or modified        |
//+------------------------------------------------------------------+
int HandleOpenPositions()
{
   int cnt;
   
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      
      if(OrderType() == OP_BUY)
      {
         if ( BuyExitSignal()) 
          {
               OrderClose(OrderTicket(),OrderLots(),Bid, Slippage, Violet);
          }
          else
          {
            if (UseTrailingStop)
            {
               HandleTrailingStop(OP_BUY,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
            }
          }
      }

      if(OrderType() == OP_SELL)
      {
         if (SellExitSignal()) //&& Close[0] > lower)
          {
             OrderClose(OrderTicket(),OrderLots(),Ask, Slippage, Violet);
          }
          else
          {
             if(UseTrailingStop)  
             {                
               HandleTrailingStop(OP_SELL,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
             }
          }
       }
   }
}
/*
//+------------------------------------------------------------------+
//| HandleTrailingStop                                               |
//| Type 1 is do not trail                                           |
//| Type 2 waits for price to move the amount of the trailStop       |
//|        before moving stop loss then moves like type 4            |
//| Type 3 moves the stoploss without delay.                         |
//+------------------------------------------------------------------+
void HandleTrailingStop(int cmd, int ticket, double op, double os, double tp)
{
   switch (TrailingStopMethod)
   {
     case 2 : Delayed_TrailingStop (cmd, ticket, op, os, tp);
              break;
     case 3 : Immediate_TrailingStop (cmd, ticket, op, os, tp);
              break;
	}
}

//+------------------------------------------------------------------+
//|                                       Immediate_TrailingStop.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by MrPip,robydoby314@yahoo.com   |
//|                                                                  |   
//| Moves the stoploss without delay.                                |
//+------------------------------------------------------------------+
void Immediate_TrailingStop(int type, int ticket, double op, double os, double tp)
{

   int digits;
   double pt, pBid, pAsk, BuyStop, SellStop;

   digits = MarketInfo(Symbol( ), MODE_DIGITS);
   
   if (type==OP_BUY)
   {
     pBid = MarketInfo(Symbol(), MODE_BID);
     pt = StopLoss * myPoint;
     if(pBid-os > pt)
     {
       BuyStop = pBid - pt;
       if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
		 BuyStop = ValidStopLoss(OP_BUY,pBid, BuyStop);   
       if (os < BuyStop) OrderModify(ticket,op,BuyStop,tp, 0,LightGreen);
		 return;
	  }
   }
   if (type==OP_SELL)
   {
     pAsk = MarketInfo(Symbol(), MODE_ASK);
     pt = StopLoss * myPoint;
     if(os - pAsk > pt)
     {
       SellStop = pAsk + pt;
       if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
       SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);  
       if (os > SellStop) OrderModify(ticket,op,SellStop,tp,0, DarkOrange);
		 return;
     }
   }   
}

//+------------------------------------------------------------------+
//|                                         Delayed_TrailingStop.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by MrPip,robydoby314@yahoo.com   |
//|                                                                  |   
//| Waits for price to move the amount of the TrailingStop           |
//| Moves the stoploss pip for pip after delay.                      |
//+------------------------------------------------------------------+
void Delayed_TrailingStop(int type, int ticket, double op, double os, double tp)
{
   int digits;
   double pt, pBid, pAsk, BuyStop, SellStop;

   pt = TrailingStop * myPoint;
   digits = MarketInfo(Symbol(), MODE_DIGITS);
   
   if (type==OP_BUY)
   {
     pBid = MarketInfo(Symbol(), MODE_BID);
     BuyStop = pBid - pt;
     if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
	  BuyStop = ValidStopLoss(OP_BUY,pBid, BuyStop);   
     if (pBid-op > pt && os < BuyStop) OrderModify(ticket,op,BuyStop,tp,0,LightGreen);
	  return;
   }
   if (type==OP_SELL)
   {
     pAsk = MarketInfo(Symbol(), MODE_ASK);
     pt = TrailingStop * myPoint;
     SellStop = pAsk + pt;
     if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
     SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);  
     if (op - pAsk > pt && os > SellStop) OrderModify(ticket,op,SellStop,tp,0,DarkOrange);
	  return;
   }   
}
//+------------------------------------------------------------------+
 */    
//+------------------------------------------------------------------+
//| Get number of lots for this trade                                |
//+------------------------------------------------------------------+ 465
double GetLots()
{
   double lot;
   
   if(MoneyManagement)
   {
     lot = LotsOptimized();
   }
   else
   {
     lot = Lots;
   }
   
   if(AccountIsMini)
   {
     if (lot < 0.1) lot = 0.1;
   }
   else
   {
     if (lot >= 1.0) lot = MathFloor(lot); else lot = 1.0;
   }
   if (lot > MaxLots) lot = MaxLots;
   
   return(lot);
}

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+ 494

double LotsOptimized()
  {
   double lot=Lots;
//---- select lot size
   lot=NormalizeDouble(MathFloor(AccountFreeMargin()*TradeSizePercent/10000)/10,1);
   
  
  // lot at this pointvalue is number of standard lots
  
//  if (Debug) Print ("Lots in LotsOptimized : ",lot);
  
  // Check if mini or standard Account
  
  if(AccountIsMini)
  {
    lot = MathFloor(lot*10)/10;
    
   }
   return(lot);
  }

//+------------------------------------------------------------------+
//| Time frame interval appropriation  function                      |
//+------------------------------------------------------------------+ 519

int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}

//+------------------------------------------------------------------+
//| Time frame string appropriation  function                        |
//+------------------------------------------------------------------+546

string func_TimeFrame_Val2String(int Value ) {
   switch(Value) {
      case 1:  // M1
         return("PERIOD_M1");
      case 2:  // M1
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " + Value);
   }
}

int func_Symbol2Val(string symbol) {
   string mySymbol = StringSubstr(symbol,0,6);
	if(mySymbol=="AUDCAD") return(1);
	if(mySymbol=="AUDJPY") return(2);
	if(mySymbol=="AUDNZD") return(3);
	if(mySymbol=="AUDUSD") return(4);
	if(mySymbol=="CHFJPY") return(5);
	if(mySymbol=="EURAUD") return(6);
	if(mySymbol=="EURCAD") return(7);
	if(mySymbol=="EURCHF") return(8);
	if(mySymbol=="EURGBP") return(9);
	if(mySymbol=="EURJPY") return(10);
	if(mySymbol=="EURUSD") return(11);
	if(mySymbol=="GBPCHF") return(12);
	if(mySymbol=="GBPJPY") return(13);
	if(mySymbol=="GBPUSD") return(14);
	if(mySymbol=="NZDUSD") return(15);
	if(mySymbol=="USDCAD") return(16);
	if(mySymbol=="USDCHF") return(17);
	if(mySymbol=="USDJPY") return(18);
	return(19);
}

//+------------------------------------------------------------------+ 596